#!/usr/bin/env python3
"""
Generates parameters for Creare fully-actuated hexarotor.
Follows labdrone doc/report.pdf (equation numbers).

Parker Lusk
plusk@mit.edu
30 May 2020
"""

import argparse

import numpy as np


class Geometry:
    """
    Given physical parameters, describe the motor geometry w.r.t the body frame
    """
    NUM_ROTORS = 6
    def __init__(self, configA, ell, alpha, h, e1, e2, d):

        self.configA = configA
        self.ell = ell
        self.alpha = alpha
        self.h = h
        self.e1 = e1
        self.e2 = e2
        self.d = d

    def _R_b_m(self, i):
        # equation (4)/(5)
        if self.configA:
            R_b_m = np.array([[np.cos((i-1)*np.pi/3.0), -np.sin((i-1)*np.pi/3.0), 0.0],
                              [np.sin((i-1)*np.pi/3.0),  np.cos((i-1)*np.pi/3.0), 0.0],
                              [0.0, 0.0, 1.0]])
        else: # configB
            R_b_m = np.array([[-np.sin((i-1)*np.pi/3.0), -np.cos((i-1)*np.pi/3.0), 0.0],
                              [ np.cos((i-1)*np.pi/3.0), -np.sin((i-1)*np.pi/3.0), 0.0],
                              [0.0, 0.0, 1.0]])
        return R_b_m

    def _r_b_bt(self, i):
        """eq (1)"""

        # equation (2)
        r_m_mt = np.array([0.0,
                          (-1)**i * self.h * np.sin(self.alpha),
                          -(self.h * np.cos(self.alpha) + (self.e1+self.e2)/2.0 + self.d)])

        # equation (3) ish
        r_m_bm = np.array([self.ell, 0.0, 0.0])

        # equation (6)
        return self._R_b_m(i) @ (r_m_bm + r_m_mt)

    def _F_b_i(self, i):
        """eq (16)"""

        # equation (15)
        F_m_ = np.array([0.0,
                         (-1)**(i-1) * np.sin(self.alpha),
                         np.cos(self.alpha)])

        return self._R_b_m(i) @ F_m_

    def param_str(self):
        config = "A" if self.configA else "B"
        return "config {}, ell={}, alpha={}, h={}, e1={}, e2={}, d={}".format(config, self.ell, np.rad2deg(self.alpha), self.h, self.e1, self.e2, self.d)

    def create_motor_positions(self):
        """Create motor positions matrix
        """

        motor_positions = np.zeros((Geometry.NUM_ROTORS,3))
        for idx in range(Geometry.NUM_ROTORS):
            motor_positions[idx,:] = self._r_b_bt(idx+1)

        return motor_positions

    def create_motor_directions(self):
        """Create motor directions matrix
        """

        motor_directions = np.zeros((Geometry.NUM_ROTORS,3))
        for idx in range(Geometry.NUM_ROTORS):
            motor_directions[idx,:] = self._F_b_i(idx+1)

        return motor_directions

    def create_motor_spin(self):
        """Create motor spin vector
        """

        # see fig 1. Motor 1 spins CW, hence it gets -1
        return np.array([-1, 1, -1, 1, -1, 1])


def print_nicely(label, mat):

    # helper to set precision and convert each element to string
    if mat.dtype == np.int:
        pstr = lambda x: "{:d}".format(x)
    else:
        pstr = lambda x: "{: .3f}".format(x)

    mat = np.atleast_2d(mat)

    s = ""
    for i in range(mat.shape[0]):
        if i > 0:
            s += " " * (len(label) + 3)
        s += ', '.join(map(pstr, mat[i,:].flatten()))
        if i < mat.shape[0]-1:
            s += ',\n'

    print("{}: [{}]".format(label, s))


if __name__ == '__main__':

    # These defaults came from measurements and CAD model measurements
    defaults = {
        'ell': 0.326, # see fig 1
        'alpha': 20, # cant angle
        'h': 0.044, # see fig 2
        'e1': 0.007, # see fig 2
        'e2': 0.016, # see fig 2
        'd': 0.013, # see fig 2
    }

    parser = argparse.ArgumentParser(add_help=False, description="Generate motor geometry parameters for labdrone hexarotor")
    parser.add_argument('--config-a', action="store_true")
    parser.add_argument('-l', '--ell', type=float, help="from body origin to motor point point", default=defaults['ell'])
    parser.add_argument('-a', '--alpha', type=float, help="cant angle (in degrees)", default=defaults['alpha'])
    parser.add_argument('-h',  type=float, help="motor base to thrust point", default=defaults['h'])
    parser.add_argument('-e1', type=float, help="small side height of wedge", default=defaults['e1'])
    parser.add_argument('-e2', type=float, help="large side height of wedge", default=defaults['e2'])
    parser.add_argument('-d',  type=float, help="thickness of carbon-fiber arm", default=defaults['d'])
    args = parser.parse_args()

    geom = Geometry(args.config_a, args.ell, np.deg2rad(args.alpha), args.h, args.e1, args.e2, args.d)

    print()
    print("# {} Autogenerated {}".format("="*30, "="*30))
    print("# {}".format(geom.param_str()))
    print("# {}==============={}".format("="*30, "="*30))
    print("# motor geometry (from body frame / geometric center)")
    print_nicely("motor_positions", geom.create_motor_positions())
    print()
    print("# unit vectors indicating direction of thrust (i.e., encodes cant angle)")
    print_nicely("motor_directions", geom.create_motor_directions())
    print()
    print("# indicates propeller spin direction (CW == -1)")
    print_nicely("motor_spin", geom.create_motor_spin())
    print("# {}==============={}".format("="*30, "="*30))
    print()